(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("vue"));
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["vue-floating"] = factory(require("vue"));
	else
		root["vue-floating"] = factory(root["Vue"]);
})((typeof self !== 'undefined' ? self : this), function(__WEBPACK_EXTERNAL_MODULE__8bbf__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "9c03");
/******/ })
/************************************************************************/
/******/ ({

/***/ "690e":
/***/ (function(module, exports) {

/*
	MIT License http://www.opensource.org/licenses/mit-license.php
	Author Tobias Koppers @sokra
*/
// css base code, injected by the css-loader
module.exports = function(useSourceMap) {
	var list = [];

	// return the list of modules as css string
	list.toString = function toString() {
		return this.map(function (item) {
			var content = cssWithMappingToString(item, useSourceMap);
			if(item[2]) {
				return "@media " + item[2] + "{" + content + "}";
			} else {
				return content;
			}
		}).join("");
	};

	// import a list of modules into the list
	list.i = function(modules, mediaQuery) {
		if(typeof modules === "string")
			modules = [[null, modules, ""]];
		var alreadyImportedModules = {};
		for(var i = 0; i < this.length; i++) {
			var id = this[i][0];
			if(typeof id === "number")
				alreadyImportedModules[id] = true;
		}
		for(i = 0; i < modules.length; i++) {
			var item = modules[i];
			// skip already imported module
			// this implementation is not 100% perfect for weird media query combinations
			//  when a module is imported multiple times with different media queries.
			//  I hope this will never occur (Hey this way we have smaller bundles)
			if(typeof item[0] !== "number" || !alreadyImportedModules[item[0]]) {
				if(mediaQuery && !item[2]) {
					item[2] = mediaQuery;
				} else if(mediaQuery) {
					item[2] = "(" + item[2] + ") and (" + mediaQuery + ")";
				}
				list.push(item);
			}
		}
	};
	return list;
};

function cssWithMappingToString(item, useSourceMap) {
	var content = item[1] || '';
	var cssMapping = item[3];
	if (!cssMapping) {
		return content;
	}

	if (useSourceMap && typeof btoa === 'function') {
		var sourceMapping = toComment(cssMapping);
		var sourceURLs = cssMapping.sources.map(function (source) {
			return '/*# sourceURL=' + cssMapping.sourceRoot + source + ' */'
		});

		return [content].concat(sourceURLs).concat([sourceMapping]).join('\n');
	}

	return [content].join('\n');
}

// Adapted from convert-source-map (MIT)
function toComment(sourceMap) {
	// eslint-disable-next-line no-undef
	var base64 = btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap))));
	var data = 'sourceMappingURL=data:application/json;charset=utf-8;base64,' + base64;

	return '/*# ' + data + ' */';
}


/***/ }),

/***/ "85cb":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);

// CONCATENATED MODULE: ./node_modules/_vue-style-loader@4.1.2@vue-style-loader/lib/listToStyles.js
/**
 * Translates the list format produced by css-loader into something
 * easier to manipulate.
 */
function listToStyles (parentId, list) {
  var styles = []
  var newStyles = {}
  for (var i = 0; i < list.length; i++) {
    var item = list[i]
    var id = item[0]
    var css = item[1]
    var media = item[2]
    var sourceMap = item[3]
    var part = {
      id: parentId + ':' + i,
      css: css,
      media: media,
      sourceMap: sourceMap
    }
    if (!newStyles[id]) {
      styles.push(newStyles[id] = { id: id, parts: [part] })
    } else {
      newStyles[id].parts.push(part)
    }
  }
  return styles
}

// CONCATENATED MODULE: ./node_modules/_vue-style-loader@4.1.2@vue-style-loader/lib/addStylesClient.js
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return addStylesClient; });
/*
  MIT License http://www.opensource.org/licenses/mit-license.php
  Author Tobias Koppers @sokra
  Modified by Evan You @yyx990803
*/



var hasDocument = typeof document !== 'undefined'

if (typeof DEBUG !== 'undefined' && DEBUG) {
  if (!hasDocument) {
    throw new Error(
    'vue-style-loader cannot be used in a non-browser environment. ' +
    "Use { target: 'node' } in your Webpack config to indicate a server-rendering environment."
  ) }
}

/*
type StyleObject = {
  id: number;
  parts: Array<StyleObjectPart>
}

type StyleObjectPart = {
  css: string;
  media: string;
  sourceMap: ?string
}
*/

var stylesInDom = {/*
  [id: number]: {
    id: number,
    refs: number,
    parts: Array<(obj?: StyleObjectPart) => void>
  }
*/}

var head = hasDocument && (document.head || document.getElementsByTagName('head')[0])
var singletonElement = null
var singletonCounter = 0
var isProduction = false
var noop = function () {}
var options = null
var ssrIdKey = 'data-vue-ssr-id'

// Force single-tag solution on IE6-9, which has a hard limit on the # of <style>
// tags it will allow on a page
var isOldIE = typeof navigator !== 'undefined' && /msie [6-9]\b/.test(navigator.userAgent.toLowerCase())

function addStylesClient (parentId, list, _isProduction, _options) {
  isProduction = _isProduction

  options = _options || {}

  var styles = listToStyles(parentId, list)
  addStylesToDom(styles)

  return function update (newList) {
    var mayRemove = []
    for (var i = 0; i < styles.length; i++) {
      var item = styles[i]
      var domStyle = stylesInDom[item.id]
      domStyle.refs--
      mayRemove.push(domStyle)
    }
    if (newList) {
      styles = listToStyles(parentId, newList)
      addStylesToDom(styles)
    } else {
      styles = []
    }
    for (var i = 0; i < mayRemove.length; i++) {
      var domStyle = mayRemove[i]
      if (domStyle.refs === 0) {
        for (var j = 0; j < domStyle.parts.length; j++) {
          domStyle.parts[j]()
        }
        delete stylesInDom[domStyle.id]
      }
    }
  }
}

function addStylesToDom (styles /* Array<StyleObject> */) {
  for (var i = 0; i < styles.length; i++) {
    var item = styles[i]
    var domStyle = stylesInDom[item.id]
    if (domStyle) {
      domStyle.refs++
      for (var j = 0; j < domStyle.parts.length; j++) {
        domStyle.parts[j](item.parts[j])
      }
      for (; j < item.parts.length; j++) {
        domStyle.parts.push(addStyle(item.parts[j]))
      }
      if (domStyle.parts.length > item.parts.length) {
        domStyle.parts.length = item.parts.length
      }
    } else {
      var parts = []
      for (var j = 0; j < item.parts.length; j++) {
        parts.push(addStyle(item.parts[j]))
      }
      stylesInDom[item.id] = { id: item.id, refs: 1, parts: parts }
    }
  }
}

function createStyleElement () {
  var styleElement = document.createElement('style')
  styleElement.type = 'text/css'
  head.appendChild(styleElement)
  return styleElement
}

function addStyle (obj /* StyleObjectPart */) {
  var update, remove
  var styleElement = document.querySelector('style[' + ssrIdKey + '~="' + obj.id + '"]')

  if (styleElement) {
    if (isProduction) {
      // has SSR styles and in production mode.
      // simply do nothing.
      return noop
    } else {
      // has SSR styles but in dev mode.
      // for some reason Chrome can't handle source map in server-rendered
      // style tags - source maps in <style> only works if the style tag is
      // created and inserted dynamically. So we remove the server rendered
      // styles and inject new ones.
      styleElement.parentNode.removeChild(styleElement)
    }
  }

  if (isOldIE) {
    // use singleton mode for IE9.
    var styleIndex = singletonCounter++
    styleElement = singletonElement || (singletonElement = createStyleElement())
    update = applyToSingletonTag.bind(null, styleElement, styleIndex, false)
    remove = applyToSingletonTag.bind(null, styleElement, styleIndex, true)
  } else {
    // use multi-style-tag mode in all other cases
    styleElement = createStyleElement()
    update = applyToTag.bind(null, styleElement)
    remove = function () {
      styleElement.parentNode.removeChild(styleElement)
    }
  }

  update(obj)

  return function updateStyle (newObj /* StyleObjectPart */) {
    if (newObj) {
      if (newObj.css === obj.css &&
          newObj.media === obj.media &&
          newObj.sourceMap === obj.sourceMap) {
        return
      }
      update(obj = newObj)
    } else {
      remove()
    }
  }
}

var replaceText = (function () {
  var textStore = []

  return function (index, replacement) {
    textStore[index] = replacement
    return textStore.filter(Boolean).join('\n')
  }
})()

function applyToSingletonTag (styleElement, index, remove, obj) {
  var css = remove ? '' : obj.css

  if (styleElement.styleSheet) {
    styleElement.styleSheet.cssText = replaceText(index, css)
  } else {
    var cssNode = document.createTextNode(css)
    var childNodes = styleElement.childNodes
    if (childNodes[index]) styleElement.removeChild(childNodes[index])
    if (childNodes.length) {
      styleElement.insertBefore(cssNode, childNodes[index])
    } else {
      styleElement.appendChild(cssNode)
    }
  }
}

function applyToTag (styleElement, obj) {
  var css = obj.css
  var media = obj.media
  var sourceMap = obj.sourceMap

  if (media) {
    styleElement.setAttribute('media', media)
  }
  if (options.ssrId) {
    styleElement.setAttribute(ssrIdKey, obj.id)
  }

  if (sourceMap) {
    // https://developer.chrome.com/devtools/docs/javascript-debugging
    // this makes source maps inside style tags work properly in Chrome
    css += '\n/*# sourceURL=' + sourceMap.sources[0] + ' */'
    // http://stackoverflow.com/a/26603875
    css += '\n/*# sourceMappingURL=data:application/json;base64,' + btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap)))) + ' */'
  }

  if (styleElement.styleSheet) {
    styleElement.styleSheet.cssText = css
  } else {
    while (styleElement.firstChild) {
      styleElement.removeChild(styleElement.firstChild)
    }
    styleElement.appendChild(document.createTextNode(css))
  }
}


/***/ }),

/***/ "8643":
/***/ (function(module, exports, __webpack_require__) {

// style-loader: Adds some css to the DOM by adding a <style> tag

// load the styles
var content = __webpack_require__("cef9");
if(typeof content === 'string') content = [[module.i, content, '']];
if(content.locals) module.exports = content.locals;
// add the styles to the DOM
var add = __webpack_require__("85cb").default
var update = add("380ca3a1", content, true, {"sourceMap":false,"shadowMode":false});

/***/ }),

/***/ "8bbf":
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE__8bbf__;

/***/ }),

/***/ "9c03":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);

// CONCATENATED MODULE: ./node_modules/_@vue_cli-service@3.10.0@@vue/cli-service/lib/commands/build/setPublicPath.js
// This file is imported into lib/wc client bundles.

if (typeof window !== 'undefined') {
  if (true) {
    __webpack_require__("e67d")
  }

  var i
  if ((i = window.document.currentScript) && (i = i.src.match(/(.+\/)[^/]+\.js(\?.*)?$/))) {
    __webpack_require__.p = i[1] // eslint-disable-line
  }
}

// Indicate to webpack that this file can be concatenated
/* harmony default export */ var setPublicPath = (null);

// CONCATENATED MODULE: ./node_modules/_cache-loader@2.0.1@cache-loader/dist/cjs.js?{"cacheDirectory":"node_modules/.cache/vue-loader","cacheIdentifier":"2c71098e-vue-loader-template"}!./node_modules/_vue-loader@15.7.1@vue-loader/lib/loaders/templateLoader.js??vue-loader-options!./node_modules/_cache-loader@2.0.1@cache-loader/dist/cjs.js??ref--0-0!./node_modules/_vue-loader@15.7.1@vue-loader/lib??vue-loader-options!./packages/floating/src/Floating.vue?vue&type=template&id=7bd815d1&
var render = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{directives:[{name:"pressMove",rawName:"v-pressMove",value:({methods: _vm.pressMove}),expression:"{methods: pressMove}"}],ref:"floating",staticClass:"floating",style:([_vm.floatStyle, _vm.rightStyle, _vm.bottomStyle]),on:{"click":_vm.tap,"touchend":_vm.touchend}},[_vm._t("default")],2)}
var staticRenderFns = []


// CONCATENATED MODULE: ./packages/floating/src/Floating.vue?vue&type=template&id=7bd815d1&

// EXTERNAL MODULE: external {"commonjs":"vue","commonjs2":"vue","root":"Vue"}
var external_commonjs_vue_commonjs2_vue_root_Vue_ = __webpack_require__("8bbf");
var external_commonjs_vue_commonjs2_vue_root_Vue_default = /*#__PURE__*/__webpack_require__.n(external_commonjs_vue_commonjs2_vue_root_Vue_);

// CONCATENATED MODULE: ./packages/floating/src/vue-finger.js
/*
 * @Description: vue自定义手指指令  详情请看 "https://github.com/gggso/vue-finger/blob/master/fingerDemo.vue"
 * @Author: 肖天翼
 * @LastEditors: Please set LastEditors
 * @Date: 2019-05-13 20:48:20
 * @LastEditTime: 2019-08-06 19:24:14
 */

function getLen(v) {
  if (isNaN(v.x) || isNaN(v.y)) {
    return 0;
  }
  return Math.sqrt(v.x * v.x + v.y * v.y);
}
function dot(v1, v2) {
  return v1.x * v2.x + v1.y * v2.y;
}
function getAngle(v1, v2) {
  const mr = getLen(v1) * getLen(v2);
  if (mr === 0) return 0;
  let r = dot(v1, v2) / mr;
  if (r > 1) r = 1;
  return Math.acos(r);
}
function cross(v1, v2) {
  return v1.x * v2.y - v2.x * v1.y;
}
function getRotateAngle(v1, v2) {
  let angle = getAngle(v1, v2);
  if (cross(v1, v2) > 0) {
    angle *= -1;
  }
  return angle * 180 / Math.PI;
}
function initConfig(self) {
  self.config = {
    preV: { x: null, y: null },
    pinchStartLen: null,
    scale: 1,
    isDoubleTap: false,
    touchStart() { },
    touchMove() { },
    touchEnd() { },
    touchCancel() { },
    tap() { },
    singleTap() { },
    longTap() { },
    doubleTap() { },
    pressMove() { },
    multipointStart() { },
    multipointEnd() { },
    swipe() { },
    pinch() { },
    rotate() { },
    delta: null,
    last: null,
    now: null,
    tapTimeout: null,
    touchTimeout: null,
    longTapTimeout: null,
    swipeTimeout: null,
    x1: null,
    x2: null,
    y1: null,
    y2: null,
    preTapPosition: { x: null, y: null },
  };
  self.start = function (e) {
    if (!e.touches) return;
    e.preventDefault();
    self.config.now = Date.now();
    self.config.x1 = e.touches[0].pageX;
    self.config.y1 = e.touches[0].pageY;
    self.config.delta = self.config.now - (self.config.last || self.config.now);
    self.config.touchStart(e);
    if (self.config.preTapPosition.x !== null) {
      self.config.isDoubleTap = (self.config.delta > 0 && self.config.delta <= 250
        && Math.abs(self.config.preTapPosition.x - self.config.x1) < 30
        && Math.abs(self.config.preTapPosition.y - self.config.y1) < 30);
    }
    self.config.preTapPosition.x = self.config.x1;
    self.config.preTapPosition.y = self.config.y1;
    self.config.last = self.config.now;
    const { preV } = self.config;
    const len = e.touches.length;
    if (len > 1) {
      self._cancelLongTap();
      const v = { x: e.touches[1].pageX - self.config.x1, y: e.touches[1].pageY - self.config.y1 };
      preV.x = v.x;
      preV.y = v.y;
      self.config.pinchStartLen = getLen(preV);
      self.config.multipointStart(e);
    }
    self.config.longTapTimeout = setTimeout(() => {
      self.config.longTap(e);
    }, 750);
  };
  self.move = function (e) {
    if (!e.touches) return;
    e.preventDefault();
    const { preV } = self.config;
    const len = e.touches.length;
    const currentX = e.touches[0].pageX;
    const currentY = e.touches[0].pageY;
    self.config.isDoubleTap = false;
    if (len > 1) {
      const v = { x: e.touches[1].pageX - currentX, y: e.touches[1].pageY - currentY };
      if (preV.x !== null) {
        if (self.config.pinchStartLen > 0) {
          e.scale = getLen(v) / self.config.pinchStartLen;
          self.config.pinch(e);
        }
        e.angle = getRotateAngle(v, preV);
        self.config.rotate(e);
      }
      preV.x = v.x;
      preV.y = v.y;
    } else {
      if (self.config.x2 !== null) {
        e.deltaX = currentX - self.config.x2;
        e.deltaY = currentY - self.config.y2;
      } else {
        e.deltaX = 0;
        e.deltaY = 0;
      }
      self.config.pressMove(e);
    }
    self.config.touchMove(e);
    self._cancelLongTap();
    self.config.x2 = currentX;
    self.config.y2 = currentY;
    if (e.touches.length > 1) {
      self._cancelLongTap();
      e.preventDefault();
    }
  };
  self.end = function (e) {
    if (!e.touches) return;
    e.preventDefault();
    self._cancelLongTap();
    if (e.touches.length < 2) {
      self.config.multipointEnd(e);
    }
    self.config.touchEnd(e);
    // swipe
    if ((self.config.x2 && Math.abs(self.config.x1 - self.config.x2) > 30)
      || (self.config.y2 && Math.abs(self.config.preV.y - self.config.y2) > 30)) {
      e.direction = self._swipeDirection(self.config.x1, self.config.x2, self.config.y1, self.config.y2);
      self.config.swipeTimeout = setTimeout(() => {
        self.config.swipe(e);
      }, 0);
    } else {
      self.config.tapTimeout = setTimeout(() => {
        self.config.tap(e);
        // trigger double tap immediately
        if (self.config.isDoubleTap) {
          self.config.doubleTap(e);
          clearTimeout(self.config.touchTimeout);
          self.config.isDoubleTap = false;
        } else {
          self.config.touchTimeout = setTimeout(() => {
            self.config.singleTap(e);
          }, 250);
        }
      }, 0);
    }
    self.config.preV.x = 0;
    self.config.preV.y = 0;
    self.config.scale = 1;
    self.config.pinchStartLen = null;
    self.config.x1 = self.config.x2 = self.config.y1 = self.config.y2 = null;
  };
  self.cancel = function (e) {
    clearTimeout(self.config.touchTimeout);
    clearTimeout(self.config.tapTimeout);
    clearTimeout(self.config.longTapTimeout);
    clearTimeout(self.config.swipeTimeout);
    self.config.touchCancel(e);
  };
  self._cancelLongTap = function (e) {
    clearTimeout(self.config.longTapTimeout);
  };
  self._swipeDirection = function (x1, x2, y1, y2) {
    return Math.abs(x1 - x2) >= Math.abs(y1 - y2) ? (x1 - x2 > 0 ? 'Left' : 'Right') : (y1 - y2 > 0 ? 'Up' : 'Down');
  };
}
const vueFinger = {};
vueFinger.install = function (Vue, options) {
  // 自定义指令
  //  点击
  Vue.directive('tap', {
    bind(el, binding, vnode, oldVnode) {
      const args = binding.value.arg || {};
      args.el = el;
      const self = {};
      initConfig(self);
      self.config.tap = function (e) {
        binding.value.methods.call(binding.value.methods, e, args);
      };
      el.addEventListener('touchstart', self.start, false);
      el.addEventListener('touchmove', self.move, false);
      el.addEventListener('touchend', self.end, false);
      el.addEventListener('touchcancel', self.cancel, false);
    },
  });
  // 单击事件，和tap的区别是相差250ms
  Vue.directive('singleTap', {
    bind(el, binding, vnode, oldVnode) {
      const args = binding.value.arg || {};
      args.el = el;
      const self = {};
      initConfig(self);
      self.config.singleTap = function (e) {
        binding.value.methods.call(binding.value.methods, e, args);
      };
      el.addEventListener('touchstart', self.start, false);
      el.addEventListener('touchmove', self.move, false);
      el.addEventListener('touchend', self.end, false);
      el.addEventListener('touchcancel', self.cancel, false);
    },
  });
  // 长按事件，当点击时长超过750ms时候触发
  Vue.directive('longTap', {
    bind(el, binding, vnode, oldVnode) {
      const args = binding.value.arg || {};
      args.el = el;
      const self = {};
      initConfig(self);
      self.config.longTap = function (e) {
        binding.value.methods.call(binding.value.methods, e, args);
      };
      el.addEventListener('touchstart', self.start, false);
      el.addEventListener('touchmove', self.move, false);
      el.addEventListener('touchend', self.end, false);
      el.addEventListener('touchcancel', self.cancel, false);
    },
  });
  // 双击事件
  Vue.directive('doubleTap', {
    bind(el, binding, vnode, oldVnode) {
      const args = binding.value.arg || {};
      args.el = el;
      const self = {};
      initConfig(self);
      self.config.doubleTap = function (e) {
        binding.value.methods.call(binding.value.methods, e, args);
      };
      el.addEventListener('touchstart', self.start, false);
      el.addEventListener('touchmove', self.move, false);
      el.addEventListener('touchend', self.end, false);
      el.addEventListener('touchcancel', self.cancel, false);
    },
  });
  // 拖拽移动事件
  Vue.directive('pressMove', {
    bind(el, binding, vnode, oldVnode) {
      const args = binding.value.arg || {};
      args.el = el;
      const self = {};
      initConfig(self);
      self.config.pressMove = function (e) {
        binding.value.methods.call(binding.value.methods, e, args);
      };
      el.addEventListener('touchstart', self.start, false);
      el.addEventListener('touchmove', self.move, false);
      el.addEventListener('touchend', self.end, false);
      el.addEventListener('touchcancel', self.cancel, false);
    },
  });
  // 多点触控事件开始事件
  Vue.directive('multipointStart', {
    bind(el, binding, vnode, oldVnode) {
      const args = binding.value.arg || {};
      args.el = el;
      const self = {};
      initConfig(self);
      self.config.multipointStart = function (e) {
        binding.value.methods.call(binding.value.methods, e, args);
      };
      el.addEventListener('touchstart', self.start, false);
      el.addEventListener('touchmove', self.move, false);
      el.addEventListener('touchend', self.end, false);
      el.addEventListener('touchcancel', self.cancel, false);
    },
  });
  // 多点触控事件结束事件
  Vue.directive('multipointEnd', {
    bind(el, binding, vnode, oldVnode) {
      const args = binding.value.arg || {};
      args.el = el;
      const self = {};
      initConfig(self);
      self.config.multipointEnd = function (e) {
        binding.value.methods.call(binding.value.methods, e, args);
      };
      el.addEventListener('touchstart', self.start, false);
      el.addEventListener('touchmove', self.move, false);
      el.addEventListener('touchend', self.end, false);
      el.addEventListener('touchcancel', self.cancel, false);
    },
  });
  // 滑动事件
  Vue.directive('swipe', {
    bind(el, binding, vnode, oldVnode) {
      const args = binding.value.arg || {};
      args.el = el;
      const self = {};
      initConfig(self);
      self.config.swipe = function (e) {
        binding.value.methods.call(binding.value.methods, e, args);
      };
      el.addEventListener('touchstart', self.start, false);
      el.addEventListener('touchmove', self.move, false);
      el.addEventListener('touchend', self.end, false);
      el.addEventListener('touchcancel', self.cancel, false);
    },
  });
  // 缩放事件
  Vue.directive('pinch', {
    bind(el, binding, vnode, oldVnode) {
      const args = binding.value.arg || {};
      args.el = el;
      const self = {};
      initConfig(self);
      self.config.pinch = function (e) {
        binding.value.methods.call(binding.value.methods, e, args);
      };
      el.addEventListener('touchstart', self.start, false);
      el.addEventListener('touchmove', self.move, false);
      el.addEventListener('touchend', self.end, false);
      el.addEventListener('touchcancel', self.cancel, false);
    },
  });
  // 旋转事件
  Vue.directive('rotate', {
    bind(el, binding, vnode, oldVnode) {
      const args = binding.value.arg || {};
      args.el = el;
      const self = {};
      initConfig(self);
      self.config.pinch = function (e) {
        binding.value.methods.call(binding.value.methods, e, args);
      };
      el.addEventListener('touchstart', self.start, false);
      el.addEventListener('touchmove', self.move, false);
      el.addEventListener('touchend', self.end, false);
      el.addEventListener('touchcancel', self.cancel, false);
    },
  });
};
/* harmony default export */ var vue_finger = (vueFinger);

// CONCATENATED MODULE: ./node_modules/_cache-loader@2.0.1@cache-loader/dist/cjs.js??ref--0-0!./node_modules/_vue-loader@15.7.1@vue-loader/lib??vue-loader-options!./packages/floating/src/Floating.vue?vue&type=script&lang=js&
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//




external_commonjs_vue_commonjs2_vue_root_Vue_default.a.use(vue_finger);
/* harmony default export */ var Floatingvue_type_script_lang_js_ = ({
  name: 'vue-floating',
  props: {
    // 是否需要贴边
    isNearBorder: {
      type: Boolean,
      default: false,
    },
    // content 距离下边的高度
    bottomMargin: {
      type: Number,
      default: 0,
    },
    // content 距离右边的长度
    rightMargin: {
      type: Number,
      default: 0,
    },
  },
  components: {

  },
  data() {
    return {
      left: 0,
      top: 0,
      setLeft: 0,
      setTop: 0,
      setRight: 0,
      setBottom: 0,
    };
  },
  computed: {
    floatStyle() {
      const self = this;
      const tempObj = {
        transform: `translate3d(${self.left}px, ${self.top}px, 0)`,
      };
      return tempObj;
    },
    bottomStyle() {
      const self = this;
      const tempObj = {
        bottom: `${self.bottomMargin}px`,
      };
      return tempObj;
    },
    rightStyle() {
      const self = this;
      const tempObj = {
        right: `${self.rightMargin}px`,
      };
      return tempObj;
    },
  },
  methods: {
    pressMove(e) {
      const self = this;
      if ((self.left) < -(self.setLeft)) {
        self.left = -(self.setLeft);
        return;
      }
      if ((self.left - 1) > (self.setRight)) {
        self.left = self.setRight;
        return;
      }
      if ((self.top) < -(self.setTop)) {
        self.top = -(self.setTop);
        return;
      }
      if ((self.top - 1) > (self.setBottom)) {
        self.top = self.setBottom;
        return;
      }
      self.left += e.deltaX;
      self.top += e.deltaY;
    },
    tap() {

    },
    touchend() {
      const self = this;
      const width = document.documentElement.clientWidth;
      if (self.isNearBorder) {
        if ((self.left + self.setLeft) < (width / 2)) {
          self.left = -(self.setLeft);
        } else {
          self.left = self.setRight;
        }
      }
    },
  },
  mounted() {
    const self = this;
    self.setLeft = self.$refs.floating.offsetLeft;
    self.setTop = self.$refs.floating.offsetTop;
    self.setRight = document.documentElement.clientWidth - self.$refs.floating.offsetWidth - self.setLeft;
    self.setBottom = document.documentElement.clientHeight - self.$refs.floating.offsetWidth - self.setTop;
  },
  created() {

  },
});

// CONCATENATED MODULE: ./packages/floating/src/Floating.vue?vue&type=script&lang=js&
 /* harmony default export */ var src_Floatingvue_type_script_lang_js_ = (Floatingvue_type_script_lang_js_); 
// EXTERNAL MODULE: ./packages/floating/src/Floating.vue?vue&type=style&index=0&lang=css&
var Floatingvue_type_style_index_0_lang_css_ = __webpack_require__("fbf1");

// CONCATENATED MODULE: ./node_modules/_vue-loader@15.7.1@vue-loader/lib/runtime/componentNormalizer.js
/* globals __VUE_SSR_CONTEXT__ */

// IMPORTANT: Do NOT use ES2015 features in this file (except for modules).
// This module is a runtime utility for cleaner component module output and will
// be included in the final webpack user bundle.

function normalizeComponent (
  scriptExports,
  render,
  staticRenderFns,
  functionalTemplate,
  injectStyles,
  scopeId,
  moduleIdentifier, /* server only */
  shadowMode /* vue-cli only */
) {
  // Vue.extend constructor export interop
  var options = typeof scriptExports === 'function'
    ? scriptExports.options
    : scriptExports

  // render functions
  if (render) {
    options.render = render
    options.staticRenderFns = staticRenderFns
    options._compiled = true
  }

  // functional template
  if (functionalTemplate) {
    options.functional = true
  }

  // scopedId
  if (scopeId) {
    options._scopeId = 'data-v-' + scopeId
  }

  var hook
  if (moduleIdentifier) { // server build
    hook = function (context) {
      // 2.3 injection
      context =
        context || // cached call
        (this.$vnode && this.$vnode.ssrContext) || // stateful
        (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext) // functional
      // 2.2 with runInNewContext: true
      if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
        context = __VUE_SSR_CONTEXT__
      }
      // inject component styles
      if (injectStyles) {
        injectStyles.call(this, context)
      }
      // register component module identifier for async chunk inferrence
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier)
      }
    }
    // used by ssr in case component is cached and beforeCreate
    // never gets called
    options._ssrRegister = hook
  } else if (injectStyles) {
    hook = shadowMode
      ? function () { injectStyles.call(this, this.$root.$options.shadowRoot) }
      : injectStyles
  }

  if (hook) {
    if (options.functional) {
      // for template-only hot-reload because in that case the render fn doesn't
      // go through the normalizer
      options._injectStyles = hook
      // register for functioal component in vue file
      var originalRender = options.render
      options.render = function renderWithStyleInjection (h, context) {
        hook.call(context)
        return originalRender(h, context)
      }
    } else {
      // inject component registration as beforeCreate hook
      var existing = options.beforeCreate
      options.beforeCreate = existing
        ? [].concat(existing, hook)
        : [hook]
    }
  }

  return {
    exports: scriptExports,
    options: options
  }
}

// CONCATENATED MODULE: ./packages/floating/src/Floating.vue






/* normalize component */

var component = normalizeComponent(
  src_Floatingvue_type_script_lang_js_,
  render,
  staticRenderFns,
  false,
  null,
  null,
  null
  
)

/* harmony default export */ var Floating = (component.exports);
// CONCATENATED MODULE: ./packages/floating/index.js
// 引入组件


Floating.install = Vue => Vue.component(Floating.name, Floating.default);

if (typeof window !== 'undefined' && window.Vue) {
  window.Vue.use(Floating);
}

/* harmony default export */ var floating = (Floating);

// CONCATENATED MODULE: ./packages/index.js
// 导入颜色选择器组件


// 存储组件列表
const components = [
  floating,
];

// 定义 install 方法，接收 Vue 作为参数。如果使用 use 注册插件，则所有的组件都将被注册
const install = function (Vue) {
  if (install.installed) return;
  install.installed = true;
  // 遍历并注册全局组件
  components.map((component) => {
    Vue.component(component.name, component);
  });
};

// 判断是否是直接引入文件
if (typeof window !== 'undefined' && window.Vue) {
  install(window.Vue);
}

/* harmony default export */ var packages_0 = ({
  // 导出的对象必须具有 install，才能被 Vue.use() 方法安装
  install,
  // 以下是具体的组件列表
  floating: floating,
});

// CONCATENATED MODULE: ./node_modules/_@vue_cli-service@3.10.0@@vue/cli-service/lib/commands/build/entry-lib.js


/* harmony default export */ var entry_lib = __webpack_exports__["default"] = (packages_0);



/***/ }),

/***/ "cef9":
/***/ (function(module, exports, __webpack_require__) {

exports = module.exports = __webpack_require__("690e")(false);
// imports


// module
exports.push([module.i, ".floating{-ms-touch-action:none;touch-action:none;position:fixed;z-index:2000}", ""]);

// exports


/***/ }),

/***/ "e67d":
/***/ (function(module, exports) {

// document.currentScript polyfill by Adam Miller

// MIT license

(function(document){
  var currentScript = "currentScript",
      scripts = document.getElementsByTagName('script'); // Live NodeList collection

  // If browser needs currentScript polyfill, add get currentScript() to the document object
  if (!(currentScript in document)) {
    Object.defineProperty(document, currentScript, {
      get: function(){

        // IE 6-10 supports script readyState
        // IE 10+ support stack trace
        try { throw new Error(); }
        catch (err) {

          // Find the second match for the "at" string to get file src url from stack.
          // Specifically works with the format of stack traces in IE.
          var i, res = ((/.*at [^\(]*\((.*):.+:.+\)$/ig).exec(err.stack) || [false])[1];

          // For all scripts on the page, if src matches or if ready state is interactive, return the script tag
          for(i in scripts){
            if(scripts[i].src == res || scripts[i].readyState == "interactive"){
              return scripts[i];
            }
          }

          // If no match, return null
          return null;
        }
      }
    });
  }
})(document);


/***/ }),

/***/ "fbf1":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var _node_modules_vue_style_loader_4_1_2_vue_style_loader_index_js_ref_6_oneOf_1_0_node_modules_css_loader_1_0_1_css_loader_index_js_ref_6_oneOf_1_1_node_modules_vue_loader_15_7_1_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_3_0_0_postcss_loader_src_index_js_ref_6_oneOf_1_2_node_modules_postcss_loader_3_0_0_postcss_loader_src_index_js_ref_6_oneOf_1_3_node_modules_cache_loader_2_0_1_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_15_7_1_vue_loader_lib_index_js_vue_loader_options_Floating_vue_vue_type_style_index_0_lang_css___WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("8643");
/* harmony import */ var _node_modules_vue_style_loader_4_1_2_vue_style_loader_index_js_ref_6_oneOf_1_0_node_modules_css_loader_1_0_1_css_loader_index_js_ref_6_oneOf_1_1_node_modules_vue_loader_15_7_1_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_3_0_0_postcss_loader_src_index_js_ref_6_oneOf_1_2_node_modules_postcss_loader_3_0_0_postcss_loader_src_index_js_ref_6_oneOf_1_3_node_modules_cache_loader_2_0_1_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_15_7_1_vue_loader_lib_index_js_vue_loader_options_Floating_vue_vue_type_style_index_0_lang_css___WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_vue_style_loader_4_1_2_vue_style_loader_index_js_ref_6_oneOf_1_0_node_modules_css_loader_1_0_1_css_loader_index_js_ref_6_oneOf_1_1_node_modules_vue_loader_15_7_1_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_3_0_0_postcss_loader_src_index_js_ref_6_oneOf_1_2_node_modules_postcss_loader_3_0_0_postcss_loader_src_index_js_ref_6_oneOf_1_3_node_modules_cache_loader_2_0_1_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_15_7_1_vue_loader_lib_index_js_vue_loader_options_Floating_vue_vue_type_style_index_0_lang_css___WEBPACK_IMPORTED_MODULE_0__);
/* unused harmony reexport * */
 /* unused harmony default export */ var _unused_webpack_default_export = (_node_modules_vue_style_loader_4_1_2_vue_style_loader_index_js_ref_6_oneOf_1_0_node_modules_css_loader_1_0_1_css_loader_index_js_ref_6_oneOf_1_1_node_modules_vue_loader_15_7_1_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_3_0_0_postcss_loader_src_index_js_ref_6_oneOf_1_2_node_modules_postcss_loader_3_0_0_postcss_loader_src_index_js_ref_6_oneOf_1_3_node_modules_cache_loader_2_0_1_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_15_7_1_vue_loader_lib_index_js_vue_loader_options_Floating_vue_vue_type_style_index_0_lang_css___WEBPACK_IMPORTED_MODULE_0___default.a); 

/***/ })

/******/ });
});
//# sourceMappingURL=vue-floating.umd.js.map